#!/usr/bin/perl

$title="FEddy 1.2 Makefile maker";

sub input {
	local($line);
	print $_[0];
	$line=<STDIN>;
	chop($line);
	$line;
}
sub addgroupmember {
	die "Can't open /etc/group!\n" unless open(group,"</etc/group");
	die "Can't open /etc/tmpgroup!\n" unless open(tmpgr,">/etc/tmpgroup");
	while ($entry = <group>) {
		chop($entry);
		print tmpgr $entry;
		if ($entry =~ /^uucp:/) {
			if ($entry =~ /:$/) {
				print tmpgr "fnet,$FEddyUser";
			} else {
				print tmpgr ",fnet,$FEddyUser";
			}
		}
		print tmpgr "\n";
	}
	close(group);
	close(tmpgr);
	system("cp /etc/group /etc/group~ ; mv /etc/tmpgroup /etc/group");
}

print "Setup for FEddy will create a user fnet and a group,\n";
print "uucp, if not already existing. You will be questioned\n";
print "the name(s) of the FEddy-Users, which will become members\n";
print "of the group uucp\n";

$FEddyUser=&input("Enter name of FEddy-User [Enter to quit] ");
if ( $FEddyUser eq "" ) {
    print "Setup stopped\n";
    exit 1;
}
print("Figuring out group and user...\n");

@fidouser=getpwnam("fnet");
@fidogroup=getgrnam("uucp");

if (!defined(@fidogroup)) {
        print("Could not group uucp...\n");
        $temp=&input("Do you want to setup group uucp [y/n]: ");
        if ( $temp ne "y" ) {
            print "Cannot setup FEddy.. exiting\n";
            exit 1;
        }
	$freegid=0;
	setgrent;
	while (@grent=getgrent) {
		if ($grent[2]>$freegid && $grent[2]<32000) {
			$freegid=$grent[2];
		}
	}
	endgrent;
	$freegid++;
	die "Can't open /etc/group!\n" unless open(group,">>/etc/group");
	print group "uucp::$freegid:fnet,root,uucp,$FEddyUser\n";
	close(group);
	@fidogroup=getgrnam("uucp");
	if (!defined(@fidogroup)) { die "Can't create group entry!\n"; }
	print "Created fido group GID $fidogroup[2]\n";
} else {
        &addgroupmember();
	print "Found fido group GID $fidogroup[2]\n";
}

if (!defined(@fidouser)) {
	$freeuid=0;
        $temp=&input("Do you want to setup user fnet [y/n]: ");
        if ( $temp ne "y" ) {
            print "Cannot setup FEddy.. exiting\n";
            exit 1;
        }
	setpwent;
	while (@pwent=getpwent) {
		if ($pwent[2]>$freeuid && $pwent[2]<32000) {
			$freeuid=$pwent[2];
		}
	}
	endpwent;
	$freeuid++;
	die "Can't open /etc/passwd!\n" unless open(passwd,">>/etc/passwd");
	print passwd "fnet::$freeuid:$fidogroup[2]:FidoNet::\n";
	close(passwd);
	@fidouser=getpwnam("fnet");
	if (!defined(@fidouser)) { die "Can't create passwd entry!\n"; }
	print "Created fido user UID $fidouser[2]\n";
} else {
	print "Found fido user UID $fidouser[2]\n";
}

if ($fidogroup[3] !~ /\buucp\b/) {
         &add_groupmember();
         @fidogroup=getgrnam("uucp");
	if (!defined(@fidogroup)) { die "Can't modify group entry!\n"; }
	if ($fidogroup[3] !~ /\buucp\b/) { die "Can't modify group entry!\n"; }
	print "Adding fido user entry in fido group memberlist\n";
} else {
	print "Found fido user entry in fido group memberlist\n";
}

@tmppath=stat("/tmp");
if (!defined(@tmppath)) {
	print "\nCan't find TEMPPATH\n";
	while (!defined(@tmppath)) {
		$temppath=&input("Please enter your TEMPPATH [/tmp]: ");
		@tmppath=stat($temppath);
	}
	$last=chop($temppath);
	$temppath.=$last;
	if ($last!~/\//) { $temppath.="/"; }
} else {
	$temppath="/tmp/";
}
print "Found TEMPPATH $temppath\n";

print "\nCreating config.h\n";

system("cp config.h config.h.old");
die "Can't create config.h!\n" unless open(conf,">config.h");
print conf <<EOF;
/*
 * This file is part of the FEddy package
 *
 * Personal use allowed under the terms of the
 *
 *              GNU GENERAL PUBLIC LICENSE Version 2
 *              (see LICENSE for the complete text)
 *
 *-------------------------------------------------------------------
 *
 *    ENTER AT YOUR OWN RISK !!
 *
 * This source is without any documentation and can drive you mad.
 * In case of sudden epileptic seizures please call your doctor.
 *
 */

#ifndef _CONFIG_H
#define _CONFIG_H

/* TEMPDIR */
#define TEMPPATH "$temppath"
#define TEMPMSG  TEMPPATH"msg.feddi"

/* charset */
#define DEFAULTCHRS 1

/* MsgBase mode */
#define FIDO_MOD 0664
#define FIDO_UID $fidouser[2]
#define FIDO_GID $fidogroup[2]

#endif
EOF
close(conf);

print "\nCONFIG-File\n";

while (!defined(@st)) {
	$bindir=&input("Enter the binary-path [/usr/bin]: ");
	if ($bindir eq "") { $bindir="/usr/bin"; }
	@st=stat($bindir);
}
$last=chop($bindir);
if ($last!~/\//) { $bindir.=$last; }

undef(@st);
while (!defined(@st)) {
	$mandir=&input("Enter the man-path [/usr/man]: ");
	if ($mandir eq "") { $mandir="/usr/man"; }
	@st=stat($mandir);
}
$last=chop($mandir);
if ($last!~/\//) { $mandir.=$last; }

$temp=&input("Do you use REDHAT5 [y/n]: ");
if ( $temp eq "y" ) {
    $INC="-DIS_REDHAT";
}
else
{
    $INC="";
}
print "\nCreating CONFIG-File\n";

system("cp CONFIG CONFIG.old");
system("cp config/Makefile.orig Makefile");
die "Can't create CONFIG!\n" unless open(mkf,">CONFIG");
#die "Can't open config/Makefile.orig!\n" unless open(omkf,"<config/Makefile.orig");
print mkf <<EOF;
# Do not edit this lines Run make config again
SRCDIR    = .
SRCMANDIR = \$(SRCDIR)/man
BINDIR    = $bindir
MANDIR    = $mandir/man1
LIBDIR    = /usr/local/lib
OWNER   = fnet
GROUP   = uucp
MANMODE = 0644
SMODE   = 4710

CFLAGS	= -pipe -O3 -fomit-frame-pointer -Wall -m486 $INC

EOF

close(mkf);
close(omkf);

print "\Modifing config.user\n";
system("cp config/config.user config/config.user.old");
die "Can't create config/config.user!\n" unless open(ncf,">config/config.user");
die "Can't open config/config.user.old!\n" unless open(ocf,"<config/config.user.old");
print ncf <<EOF;
#!/usr/bin/perl

\$FEDDISRC="$ENV{'PWD'}";
EOF
$_=<ocf>;
$_=<ocf>;
$_=<ocf>;
while (<ocf>) { print ncf; }
close(ncf);
close(ocf);

print "\nDone.\n";
